#extension GL_OES_EGL_image_external : require
precision mediump float;
uniform samplerExternalOES uTexture;
varying vec2 vTexCoord;
uniform vec2 offset;
uniform vec4 switch_area;
uniform int enhance;
uniform float blurKernel[13];
uniform int blurKernelSz;
uniform float factor;
uniform float threshold;
void main() {
    if (enhance == 0)  {
        gl_FragColor = texture2D(uTexture, vTexCoord);
    } else if (enhance == 2) {
//        vec4 color00 = texture2D(uTexture, vTexCoord-offset);
        vec4 color01 = texture2D(uTexture, vTexCoord-vec2(0.0, offset.y));
//        vec4 color02 = texture2D(uTexture, vTexCoord+vec2(offset.x, -offset.y));
        vec4 color10 = texture2D(uTexture, vTexCoord-vec2(offset.x, 0.0));
        vec4 color = texture2D(uTexture, vTexCoord+vec2(0.0, 0.0));
        vec4 color12 = texture2D(uTexture, vTexCoord+vec2(offset.x, 0.0));
//        vec4 color20 = texture2D(uTexture, vTexCoord+vec2(-offset.x, offset.y));
        vec4 color21 = texture2D(uTexture, vTexCoord+vec2(0.0, offset.y));
//        vec4 color22 = texture2D(uTexture, vTexCoord+offset);
        // gl_FragColor = vec4((color * (9.0 + 0.00) - color00 - color01 - color02 - color10 - color12 - color20 - color21 - color22).xyz, 1.0);
        vec4 mask = color * 2.0 - (color01  + color10 + color12 + color21) * 0.5;
        float Y = dot(color.wyz, vec3(0.299, 0.587, 0.114));
        float preserve = 1.0;
        if (Y < 15.0 / 255.0) {
            preserve = Y * (255.0 / 15.0);
        }
        if (Y > 240.0 / 255.0) {
            preserve = (1.0 - Y) * (255.0 / 15.0);
        }
        gl_FragColor = vec4((color + mask * preserve).xyz, 1.0);
    } else if (enhance == 1) {
        int sz = blurKernelSz / 2;
        vec4 sum = vec4(0.0);
        for (int i = 0; i < blurKernelSz; i++) {
            float di = float(i - sz) * offset.x;
            for (int j = 0; j < blurKernelSz; j++) {
                float dj = float(j - sz) * offset.y;
                vec4 color = texture2D(uTexture, vTexCoord + vec2(di, dj));
                sum = sum + color * blurKernel[i] * blurKernel[j];
            }
        }
        vec4 color = texture2D(uTexture, vTexCoord);
        vec4 mask = color - sum;
        float Y = dot(color.wyz, vec3(0.299, 0.587, 0.114));
        float preserve = factor;
        if (Y < 15.0 / 255.0) {
            preserve *= Y * (255.0 / 15.0);
        }
        if (Y > 240.0 / 255.0) {
            preserve *= (1.0 - Y) * (255.0 / 15.0);
        }
        mask = vec4(greaterThan(abs(mask), vec4(threshold/255.0))) * mask * preserve;
        gl_FragColor = color + mask;
    }
}
